using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;
using System.Configuration;
using System.Collections.Generic;
using System.Web.UI.HtmlControls;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;

using Telerik.Web.UI;

namespace RadSchedulerWebPart
{
    public class SchedulerWebPart: Microsoft.SharePoint.WebPartPages.WebPart
    {
        private RadScheduler theScheduler = null;

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            // Create the table that will hold the toolbar and the calendar
            HtmlTable theMainTable = new HtmlTable();
            theMainTable.Width = "100%";
            theMainTable.CellPadding = 0;
            theMainTable.CellSpacing = 0;
            theMainTable.Border = 0;
            this.Controls.Add(theMainTable);

            // Create the row and the cell for the calendar
            HtmlTableRow calendarRow = new HtmlTableRow();
            theMainTable.Rows.Add(calendarRow);
            HtmlTableCell calendarCell = new HtmlTableCell();
            calendarRow.Cells.Add(calendarCell);

            CheckScriptManager();

            theScheduler = new RadScheduler();
            theScheduler.Skin = "Office2007";
            // Disable the timeline view
            theScheduler.TimelineView.UserSelectable = false;
            theScheduler.Width = new Unit(800, UnitType.Pixel);
            theScheduler.Height = new Unit(600, UnitType.Pixel);
            theScheduler.OverflowBehavior = OverflowBehavior.Expand;
            theScheduler.Provider = new ListSchedulerProvider();
            theScheduler.SelectedView = SchedulerViewType.WeekView;

            // The following line plus the CSS classes added in the Default.aspx
            // caused the appointments to cross the boundary of the month cell
            theScheduler.MonthView.VisibleAppointmentsPerDay = 5;            

            this.Controls.Add(theScheduler);
        }

        private ScriptManager CheckScriptManager()
        {
            ScriptManager sm = ScriptManager.GetCurrent(Page);
            if (sm == null)
            {
                if (Page.Form != null)
                {
                    sm = new ScriptManager();
                    sm.ID = Page.Form.ID + "_ScriptManager";
                    Page.Form.Controls.Add(sm);
                }
            }

            return sm;
        }
    }

    public class ListSchedulerProvider : SchedulerProviderBase
    {
        public override void Delete(RadScheduler owner, Appointment appointmentToDelete)
        {

        }

        public override System.Collections.Generic.IEnumerable<Appointment> GetAppointments(RadScheduler owner)
        {
            List<Appointment> appointmentsList = new List<Appointment>();

            Appointment newAppt = new Appointment();
            newAppt.Start = new DateTime(2008, 7, 14, 0, 0, 0);
            newAppt.End = newAppt.Start.AddDays(1);
            newAppt.ID = Guid.NewGuid();
            newAppt.Subject = "All Day 1";
            newAppt.ToolTip = "All Day 1";
            newAppt.RecurrenceState = RecurrenceState.NotRecurring;
            appointmentsList.Add(newAppt);

            newAppt = new Appointment();
            newAppt.Start = new DateTime(2008, 7, 14, 0, 0, 0);
            newAppt.End = newAppt.Start.AddDays(1);
            newAppt.ID = Guid.NewGuid();
            newAppt.Subject = "All Day 2";
            newAppt.ToolTip = "All Day 2";
            newAppt.RecurrenceState = RecurrenceState.NotRecurring;
            appointmentsList.Add(newAppt);

            newAppt = new Appointment();
            newAppt.Start = new DateTime(2008, 7, 14, 0, 0, 0);
            newAppt.End = newAppt.Start.AddDays(1);
            newAppt.ID = Guid.NewGuid();
            newAppt.Subject = "All Day 3";
            newAppt.ToolTip = "All Day 3";
            newAppt.RecurrenceState = RecurrenceState.NotRecurring;
            appointmentsList.Add(newAppt);

            return appointmentsList;
        }

        public override System.Collections.Generic.IEnumerable<ResourceType> GetResourceTypes(RadScheduler owner)
        {
            return null;
        }

        public override System.Collections.Generic.IEnumerable<Resource> GetResourcesByType(RadScheduler owner, string resourceType)
        {
            return null;
        }

        public override void Insert(RadScheduler owner, Appointment appointmentToInsert)
        {

        }

        public override void Update(RadScheduler owner, Appointment appointmentToUpdate)
        {

        }
    }

}
